.\" $Id: tart.man,v 1.12 2012/08/14 21:18:45 ksb Exp $
.\" by Kevin Braunsdorf
.\" $Compile: Display%h
.\" $Display: ${groff:-groff} -Tascii -man %f |${PAGER:-less}
.\" $Display(*): ${groff:-groff} -T%s -man %f
.\" $Install: %b -mDeinstall %o %f && cp %f $DESTDIR/usr/local/man/man1/tart.1
.\" $Deinstall: ${rm-rm} -f $DESTDIR/usr/local/man/[cm]a[nt]1/tart.1*
.TH TART 1 LOCAL
.SH NAME
tart - filter tar files to remove unwanted members
.SH SYNOPSIS
.ds PN "tart
\fI\*(PN\fP [\fB\-1\fP\fBb\fP\fBn\fP\fBr\fP\fBv\fP] [\fB\-O\fP\~\fIcaught\fP] [\fIpatterns\fP]
.br
\fI\*(PN\fP \fB\-h\fP
.br
\fI\*(PN\fP \fB\-V\fP

.SH DESCRIPTION
The \fBtar\fP program has no good way to delete member files
from the aggregate archive.  \fITart\fP inspects each member
file in an input \fBtar\fP file (from \fIstdin\fP) coping
any unrecognized members to \fIstdout\fP.
.P
All recognized members are output to the file \fIcaught\fP in
\fBtar\fP format.  The two resulting files (together) contain the same
members as the original input file.
.P
The glob \fIpatterns\fP used in the program are extended
\fBsh\fP patterns.  In addition to the standard meta characters
(*, ?, []) the sequence ``**'' will match any number of any
characters including a slash (/).

.SH OPTIONS
If the program is called as \fI\*(PN\fP then no options are forced.
.TP
\fB\-1\fP
Remove each \fIpattern\fP from the list after it matches the first file.
.TP
\fB\-b\fP
Do not pad output files to an even multiple of 20 blocks.  This makes
a broken \fBtar\fP(1) file in some cases.
.TP
\fB\-h\fP
Print only a brief help message.
.TP
\fB\-n\fP
Do not execute commands, trace only.  This is only useful with \fB\-v\fP.
.TP
\fB\-O\fP \fIcaught\fP
By default the caught members are output to \fB/dev/null\fP.
These members may be captured in another file, \fIcaught\fP,
if they are useful.
.TP
\fB\-r\fP
Reverse the output streams -- matches to stdout, non matches to
\fIcaught\fP.
.TP
\fB\-v\fP
Be verboses, show the index of members, their size and disposition..
.TP
\fB\-V\fP
Show version information.
.SH EXAMPLES
.TP
tart \-O keep.tar "*.c" "*.h" "Makefile" <all.tar >bin.tar
From \fBall.tar\fP divert the source files
(C files and the \fBmake\fP(1) recipe) to
\fBkeep.tar\fP leaving any binary or other files in \fBbin.tar\fP.

.TP
tart "**/.owners" ".owners" <mtp.tar >send.tar
Delete any \fBinstallus\fP \fB.owners\fP control files from
the \fBmtp.tar\fP aggregate, put the remander in \fBsend.tar\fP.

.TP
tart \-1 Makefile Makefile <src.tar | tar xf \-
Remove up to 2 copies of a top level \fBMakefile\fP from the
\fBsrc.tar\fP file.  Any remaining copies of \fBMakefile\fP
and all other files will be unpacked.

.TP
tar cf \- . | tart \-r "**,v" >rcs.tar
Create a tar file of only all the \fBrcs\fP delta files in the
current directory.

.SH BUGS
None confirmed, only some reports of breaking GNU tar files.

.SH AUTHOR
Kevin Braunsdorf, NonPlayer Character Guild
.br
tart swirl ksb.npcguild.org
.SH "SEE ALSO"
.hlm 0
sh(1), tar(1), make(1), installus(1l)
